<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 12.03.2015
 */
use yii\db\Schema;
use yii\db\Migration;

class m150312_100547_create_slider_table extends Migration
{
    public function up()
    {
        $tableExist = $this->db->getTableSchema("{{%slider_slider}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%slider_slider}}", [
            'id'                    => Schema::TYPE_PK,

            'created_by'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_by'            => Schema::TYPE_INTEGER . ' NULL',

            'created_at'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_at'            => Schema::TYPE_INTEGER . ' NULL',

            'name'                  => Schema::TYPE_STRING . '(255) NOT NULL',
            'description'           => Schema::TYPE_TEXT . ' NULL',

            'files'                 => Schema::TYPE_TEXT. ' NULL',

            'code'                 => Schema::TYPE_STRING. '(32) NULL',

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%slider_slider}} ADD INDEX(updated_by);");
        $this->execute("ALTER TABLE {{%slider_slider}} ADD INDEX(created_by);");

        $this->execute("ALTER TABLE {{%slider_slider}} ADD INDEX(created_at);");
        $this->execute("ALTER TABLE {{%slider_slider}} ADD INDEX(updated_at);");

        $this->execute("ALTER TABLE {{%slider_slider}} ADD INDEX(name);");

        $this->execute("ALTER TABLE {{%slider_slider}} ADD UNIQUE(code);");

        $this->execute("ALTER TABLE {{%slider_slider}} COMMENT = 'Слайдеры';");

        $this->addForeignKey(
            'slider_slider_created_by', "{{%slider_slider}}",
            'created_by', '{{%cms_user}}', 'id', 'RESTRICT', 'RESTRICT'
        );

        $this->addForeignKey(
            'slider_slider_updated_by', "{{%slider_slider}}",
            'updated_by', '{{%cms_user}}', 'id', 'RESTRICT', 'RESTRICT'
        );
    }

    public function down()
    {
        $this->dropForeignKey("slider_slider_created_by", "{{%slider_slider}}");
        $this->dropForeignKey("slider_slider_updated_by", "{{%slider_slider}}");

        $this->dropTable("{{%slider_slider}}");
    }
}