<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 12.03.2015
 */
use yii\db\Schema;
use yii\db\Migration;

class m150312_100557_create_slide_table extends Migration
{
    public function up()
    {
        $tableExist = $this->db->getTableSchema("{{%slider_slide}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%slider_slide}}", [
            'id'                    => Schema::TYPE_PK,

            'created_by'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_by'            => Schema::TYPE_INTEGER . ' NULL',

            'created_at'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_at'            => Schema::TYPE_INTEGER . ' NULL',

            'name'                  => Schema::TYPE_STRING . '(255) NOT NULL',
            'description'           => Schema::TYPE_TEXT . ' NULL',

            'url'                   => Schema::TYPE_STRING . '(255) NULL',

            'files'                 => Schema::TYPE_TEXT. ' NULL',

            'slider_id'             => Schema::TYPE_INTEGER. ' NOT NULL',
            'priority'               => Schema::TYPE_INTEGER . '  NOT NULL DEFAULT 0',

            'status'                => Schema::TYPE_SMALLINT . ' NOT NULL DEFAULT 10', //статус, активна некативна, удалено

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(updated_by);");
        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(created_by);");

        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(created_at);");
        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(updated_at);");

        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(name);");
        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(url);");
        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(status);");
        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(slider_id);");
        $this->execute("ALTER TABLE {{%slider_slide}} ADD INDEX(priority);");

        $this->execute("ALTER TABLE {{%slider_slide}} COMMENT = 'Слайды';");

        $this->addForeignKey(
            'slider_slide_created_by', "{{%slider_slide}}",
            'created_by', '{{%cms_user}}', 'id', 'RESTRICT', 'RESTRICT'
        );

        $this->addForeignKey(
            'slider_slide_updated_by', "{{%slider_slide}}",
            'updated_by', '{{%cms_user}}', 'id', 'RESTRICT', 'RESTRICT'
        );

        $this->addForeignKey(
            'slider_slide_slider_id', "{{%slider_slide}}",
            'slider_id', '{{%slider_slider}}', 'id', 'RESTRICT', 'RESTRICT'
        );
    }

    public function down()
    {
        $this->dropForeignKey("slider_slide_created_by", "{{%slider_slide}}");
        $this->dropForeignKey("slider_slide_updated_by", "{{%slider_slide}}");
        $this->dropForeignKey("slider_slide_slider_id", "{{%slider_slide}}");

        $this->dropTable("{{%slider_slide}}");
    }
}