<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 10.03.2015
 */
namespace skeeks\modules\cms\slider\models;

use skeeks\cms\base\db\ActiveRecord;
use skeeks\cms\models\behaviors\HasDescriptionsBehavior;
use skeeks\cms\models\behaviors\HasFiles;
use skeeks\cms\models\behaviors\HasStatus;
use skeeks\cms\models\behaviors\Implode;
use skeeks\cms\models\Core;

/**
 * Class ProductPropertyGroup
 * @package skeeks\modules\cms\catalog\models
 */
class Slide extends Core
{
    use \skeeks\cms\models\behaviors\traits\HasFiles;

    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return '{{%slider_slide}}';
    }

    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return array_merge(parent::behaviors(), [
            HasFiles::className() => [
                "class"  => HasFiles::className(),
            ],
        ]);
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return array_merge(parent::rules(), [
            [['slider_id'], 'required'],
            [['slider_id', 'priority'], 'integer'],
            ['priority', 'default', 'value' => 0],
            [['name', 'description', 'url'], 'string'],
        ]);
    }

    public function scenarios()
    {
        $scenarios = parent::scenarios();

        $scenarios['create'] = $scenarios[self::SCENARIO_DEFAULT];
        $scenarios['update'] = $scenarios[self::SCENARIO_DEFAULT];

        return $scenarios;
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return  array_merge(parent::attributeLabels(), [
            'id' => \Yii::t('app', 'ID'),
            'name' => \Yii::t('app', 'Name'),
            'description' => \Yii::t('app', 'Description'),
            'url' => \Yii::t('app', 'Ссылка'),
            'priority' => \Yii::t('app', 'Приоритет'),
            'slider_id' => \Yii::t('app', 'Слайдер'),
        ]);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function findSlider()
    {
        return $this->hasOne(Slider::className(), ['id' => 'slider_id']);
    }

    /**
     * @return Slider
     */
    public function fetchSlider()
    {
        return $this->findSlider()->one();
    }

}