<?php
/**
 * Publications
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 08.12.2014
 * @since 1.0.0
 */
namespace skeeks\modules\cms\slider\widgets\slider;

use skeeks\cms\base\Widget;
use skeeks\cms\models\Publication;
use skeeks\cms\models\Search;
use skeeks\cms\models\Tree;
use skeeks\cms\widgets\base\hasModels\WidgetHasModels;
use skeeks\cms\widgets\base\hasModelsSmart\WidgetHasModelsSmart;
use skeeks\cms\widgets\WidgetHasTemplate;
use skeeks\modules\cms\slider\models\Slide;
use Yii;
use yii\data\Pagination;
use yii\helpers\ArrayHelper;

/**
 * Class Slider
 * @package skeeks\modules\cms\slider\widgets\slider
 */
class Slider extends \skeeks\cms\widgets\base\hasTemplate\WidgetHasTemplate
{
    /**
     * @var null|string
     */
    public $slider_id               = '';

    public function rules()
    {
        return ArrayHelper::merge(parent::rules(), [
            [['slider_id'], 'integer'],
            [['slider_id'], 'required'],
        ]);
    }

    public function attributeLabels()
    {
        return ArrayHelper::merge(parent::attributeLabels(), [
            'slider_id'                         => 'Слайдер',
        ]);
    }


    /**
     * Подготовка данных для шаблона
     * @return $this
     */
    public function bind()
    {
        $this->_data->slides = Slide::find()->where(['slider_id' => $this->slider_id])->orderBy('priority DESC')->all();
        return $this;
    }



}
